// This file is part of Moonlight Creator
//   Copyright (C) 1996-1998  Stephane Rehel
//
// This library is free software; you can redistribute it and/or
// modify it under the terms of the GNU Library General Public
// License as published by the Free Software Foundation; either
// version 2 of the License, or (at your option) any later version.
//
// This library is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// Library General Public License for more details.
//
// You should have received a copy of the GNU Library General Public
// License along with this library; if not, write to the Free
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

/*
  TmplModes.C

  Stephane Rehel

  October 19 1997
*/

#include "TmplModes.h"

#include "interface/MLModes.h"

#include "modes/TmplMSelect.h"
#include "modes/TmplMDrag.h"
#include "modes/TmplMClick.h"

/////////////////////////////////////////////////////////////////////////////

// static
void TmplModes::init( TmplModule* tmpl, MLModes* m )
{
  if( m == 0 )
    return;

  m->add( SELECT, new TmplMSelect(tmpl) );
  m->add( DRAG,   new TmplMDrag(tmpl) );
  m->add( CLICK,  new TmplMClick(tmpl) );
}

/////////////////////////////////////////////////////////////////////////////
