// This file is part of Moonlight Creator
//   Copyright (C) 1996-1998  Stephane Rehel
//
// This library is free software; you can redistribute it and/or
// modify it under the terms of the GNU Library General Public
// License as published by the Free Software Foundation; either
// version 2 of the License, or (at your option) any later version.
//
// This library is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// Library General Public License for more details.
//
// You should have received a copy of the GNU Library General Public
// License along with this library; if not, write to the Free
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

/*
  TmplFSelect.C

  Stephane Rehel

  October 19 1997
*/

#include "TmplFSelect.h"

#include "tools/IntegerArray.h"

#include "tmpl/TmplModule.h"
#include "tmpl/TmplModes.h"
#include "tmpl/TmplCommand.h"
#include "tmpl/TmplCommands.h"

#include "tmpl/modes/TmplMSelect.h"

/////////////////////////////////////////////////////////////////////////////

TmplFSelect::TmplFSelect( MLModule* _module ):
  MLBaseFunction(_module)
{}

/////////////////////////////////////////////////////////////////////////////

TmplFSelect::~TmplFSelect()
{}

/////////////////////////////////////////////////////////////////////////////

IBOOL TmplFSelect::_call()
{
  module->enterMode(TmplModes::SELECT);

  TmplModule* tmpl= (TmplModule*) module;

  tmpl->pushMessage( "Select function" );

  while( ! exitFunction )
    {
    if( ! interfaceYield() )
      break;

    TmplMSelect* s= (TmplMSelect*) tmpl->getMode(TmplModes::SELECT);
    if( s == 0 )
      break;

    TmplCommand* cmd= new TmplCommand;
    cmd->type= TmplCommands::SELECT;
    cmd->indices= s->objects;

    tmpl->post(cmd);
    }

  tmpl->popMessage();

  module->leaveMode();

  return ITRUE;
}

/////////////////////////////////////////////////////////////////////////////
